package com.huimv.environ.server;

import com.huimv.environ.dao.entity.EnvironmentDataEntity;
import com.huimv.environ.dao.repo.EnvironmentDataRepo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Component
public class EnvironDataHandler {
    @Autowired
    private EnvironmentDataRepo environmentDataRepo;

    //
    private void handleReceiveData(String receiveData) {
        EnvironmentDataEntity environmentDataEntity = new EnvironmentDataEntity();
        /** 处理参数 */
        Map envMap = getEnvData(receiveData);
        System.out.println("TEST envMap>>"+envMap);
        if (!envMap.isEmpty()) {
            environmentDataEntity.setDate(envMap.get("date").toString());
            environmentDataEntity.setHour(Integer.parseInt(envMap.get("hour").toString()));
            environmentDataEntity.setQn(envMap.get("qn").toString());
            environmentDataEntity.setDateTime(envMap.get("datatime").toString());
            environmentDataEntity.setHxxyl(envMap.get("hxxyl").toString());
            environmentDataEntity.setAd(envMap.get("ad").toString());
            environmentDataEntity.setZl(envMap.get("zl").toString());
            environmentDataEntity.setZd(envMap.get("zd").toString());
            environmentDataEntity.setPh(envMap.get("ph").toString());
            environmentDataEntity.setWs(Float.parseFloat(envMap.get("ws").toString()));
            environmentDataEntity.setWslj(Float.parseFloat(envMap.get("wslj").toString()));
            environmentDataRepo.save(environmentDataEntity);
        } else {
            System.out.println("空数据");
        }
        /*  */
//        return getResultMap("code","message",null);
    }

    //处理污水数据
    private Map getEnvData(String receiveData) {
        Map dataMap = new HashMap();
        String[] allArray = receiveData.split(";");
        if (allArray != null && allArray.length > 0) {
            for (int b = 0; b < allArray.length; b++) {
                if (allArray[b].indexOf("QN=") != -1) {
                    String data = allArray[b];
                    dataMap.put("qn", data.substring(data.indexOf("=") + 1, data.length()));
                }
                if (allArray[b].indexOf("DataTime=") != -1) {
                    String data = allArray[b];
                    String datatime = data.substring(data.lastIndexOf("=") + 1, data.length());
                    dataMap.put("datatime", datatime);
                    String date = datatime.substring(0, 8);
                    String hour = datatime.substring(8, 10);
                    dataMap.put("date", date);
                    dataMap.put("hour", hour);
                }
                if (allArray[b].indexOf("001-Avg=") != -1) {
                    String unitData = allArray[b];
                    if (unitData != null) {
                        String[] unitDataArray = unitData.split(",");
                        for (int c = 0; c < unitDataArray.length; c++) {
                            if (unitDataArray[c].indexOf("001-Avg=") != -1) {
                                String data = unitDataArray[c];
                                dataMap.put("ph", data.substring(data.indexOf("=") + 1, data.length()));
                                break;
                            }
                        }
                    }
                }
                if (allArray[b].indexOf("011-Avg=") != -1) {
                    String unitData = allArray[b];
                    if (unitData != null) {
                        String[] unitDataArray = unitData.split(",");
                        for (int c = 0; c < unitDataArray.length; c++) {
                            if (unitDataArray[c].indexOf("011-Avg=") != -1) {
                                String data = unitDataArray[c];
                                dataMap.put("hxxyl", data.substring(data.indexOf("=") + 1, data.length()));
                                break;
                            }
                        }
                    }
                }
                if (allArray[b].indexOf("060-Avg=") != -1) {
                    String unitData = allArray[b];
                    if (unitData != null) {
                        String[] unitDataArray = unitData.split(",");
                        for (int c = 0; c < unitDataArray.length; c++) {
                            if (unitDataArray[c].indexOf("060-Avg=") != -1) {
                                String data = unitDataArray[c];
                                dataMap.put("ad", data.substring(data.indexOf("=") + 1, data.length()));
                                break;
                            }
                        }
                    }
                }
                if (allArray[b].indexOf("065-Avg=") != -1) {
                    String unitData = allArray[b];
                    if (unitData != null) {
                        String[] unitDataArray = unitData.split(",");
                        for (int c = 0; c < unitDataArray.length; c++) {
                            if (unitDataArray[c].indexOf("065-Avg=") != -1) {
                                String data = unitDataArray[c];
                                dataMap.put("zd", data.substring(data.indexOf("=") + 1, data.length()));
                                break;
                            }
                        }
                    }
                }
                if (allArray[b].indexOf("101-Avg=") != -1) {
                    String unitData = allArray[b];
                    if (unitData != null) {
                        String[] unitDataArray = unitData.split(",");
                        for (int c = 0; c < unitDataArray.length; c++) {
                            if (unitDataArray[c].indexOf("101-Avg=") != -1) {
                                String data = unitDataArray[c];
                                dataMap.put("zl", data.substring(data.indexOf("=") + 1, data.length()));
                                break;
                            }
                        }
                    }
                }
                if (allArray[b].indexOf("B01-Avg=") != -1) {
                    String unitData = allArray[b];
                    if (unitData != null) {
                        String[] unitDataArray = unitData.split(",");
                        for (int c = 0; c < unitDataArray.length; c++) {
                            if (unitDataArray[c].indexOf("B01-Avg=") != -1) {
                                String data = unitDataArray[c];
                                dataMap.put("ws", data.substring(data.indexOf("=") + 1, data.length()));
                                break;
                            }
                        }
                    }
                }
            }
        }
        String ws = dataMap.get("ws").toString();
//        /** 查询污水量并汇总 */
//        float wslj = getTotalEffluent(ws);
        dataMap.put("wslj", 0);
        return dataMap;
    }
}
